Please use the Apache issue tracking system for new NetBeans issues (https://issues.apache.org/jira/projects/NETBEANS0/issues) !!
Bug 24888 - Make core-*.jar modules autoloads or eager, not on classpath
Make core-*.jar modules autoloads or eager, not on classpath
Status: RESOLVED FIXED
Product: platform
Classification: Unclassified
Component: -- Other --
3.x
All All
: P3 (vote)
: 3.x
Assigned To: Jesse Glick
issues@platform
:
Depends on: 28471 32403 32404
Blocks: 17815
  Show dependency treegraph
 
Reported: 2002-06-17 18:20 UTC by Jesse Glick
Modified: 2008-12-22 20:02 UTC (History)
2 users (show)

See Also:
Issue Type: TASK
:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Jesse Glick 2002-06-17 18:20:50 UTC
Currently all the core-*.jar modules are in the
lib/ directory. They should be made into proper
modules instead, to clean up the classpath.

1. Those which provide some service which might
not always be needed, should be made autoloads,
OIDE-M-Provides some token. E.g. compilation and
execution modules would provide CompilationEngine
and ExecutionEngine, respectively. Old modules
would automatically Require these tokens; new
modules would have to ask for them explicitly. See
NbInstaller for more.

2. Those which are simply needed for normal
operation of the IDE, e.g. window system or UI,
should be made eager modules, ensuring they cannot
be turned off by the user.

Don't forget some things:

a. Update NbInstaller to not bother masking out
Java packages which are no longer in the classpath
anyway. The normal classloader mechanism will do
this correctly anyway.

b. Any real core code accessing these modules will
need to be rewritten to not have a compile-time
(or hard run-time!) dependency.

c. nbresboot: -> nbres: for e.g. DTDs.
Comment 1 Marek Grummich 2002-07-22 08:40:43 UTC
Target milestone was changed from '3.4' to TBD.
Comment 2 Marek Grummich 2002-07-22 09:02:52 UTC
Target milestone was changed from '3.4' to TBD.
Comment 3 Jesse Glick 2002-08-14 22:41:19 UTC
Now mine, I guess.
Comment 4 Jesse Glick 2002-09-26 06:51:56 UTC
Done (c) in working sources (deprecated nbresboot:).
Comment 5 Jesse Glick 2002-10-28 18:34:15 UTC
In progress in separation_19443_b branch; all but core-windows.jar are
moved.
Comment 6 Jesse Glick 2002-11-02 21:33:44 UTC
Only core-windows.jar remains on the classpath. Due to the difficulty
of pulling the window system out of the rest of core, I do not expect
this to be fixed for NB 4.0.
Comment 7 Jesse Glick 2003-05-07 16:17:27 UTC
Well, it's done now! Thanks Peter.


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2014, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo